"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Vars = void 0;
const element_shadow_1 = require("../element-shadow");
class Vars extends element_shadow_1.ElementShadow {
    props;
    ignoreVarsBeforeExec = ['props'];
    async init(props) {
        this.props = props;
    }
    async exec() {
        this.props = await this.scene.getVars(this.props, this);
        this.logger.trace(`[%s] \t%j`, this.tag, this.props);
        if (!this.props || Array.isArray(this.props) || typeof this.props !== 'object')
            return;
        this.merge();
        return this.props;
    }
    merge() {
        const { globalVars, sceneVars } = Vars.splitGlobalSceneVars(this.props);
        this.rootScene.mergeGlobalVars(globalVars);
        this.scene.mergeVars(sceneVars);
    }
    static splitGlobalSceneVars(props) {
        return Object.keys(props)
            .reduce((sum, key) => {
            if (/[A-Z]/.test(key[0])) {
                sum.globalVars[key] = props[key];
            }
            else {
                sum.sceneVars[key] = props[key];
            }
            return sum;
        }, { globalVars: {}, sceneVars: {} });
    }
}
exports.Vars = Vars;
//# sourceMappingURL=vars.js.map